## tarantool 1.5.1.84.g9f2e646

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(tarantool C CXX)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
set(CMAKE_INCLUDE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_INCLUDE_PATH})


include(CheckLibraryExists)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceRuns)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(TestBigEndian)
include(CheckFunctionExists)
include(FindOptionalPackage)

find_program(ECHO echo)
find_program(XSLTPROC xsltproc)
find_program(XMLLINT xmllint)
find_program(JING jing)
find_program(LYNX lynx)
find_program(CAT cat)
find_program(GIT git)
find_program(RAGEL ragel)
find_program(CONFETTI confetti)
find_program(LD ld)
find_program(POD2MAN pod2man)


#
# This instructs the rest of the build system what product
# and what modules to produce.
#
set (TARANTOOL_PRODUCT "box")
set (TARANTOOL_MODULES "box")
set (TARANTOOL_CLIENTS "tarancheck" "tarantar")
# Define PACKAGE macro in tarantool/config.h
set (PACKAGE "Tarantool")

#
# Set default build type to Debug. This is to ease a developer's
# life. Release binaries are built by BuildBot automatically anyway.
#
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

if(NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR lib)
endif(NOT DEFINED CMAKE_INSTALL_LIBDIR)

set(PLUGIN_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/tarantool/plugins")

include(cmake/utils.cmake)

# the order is significant: we need to know os and compiler to configure libs
include(cmake/arch.cmake)
include(cmake/os.cmake)
include(cmake/compiler.cmake)
include(cmake/simd.cmake)
include(cmake/profile.cmake)

check_symbol_exists(MAP_ANON sys/mman.h HAVE_MAP_ANON)
check_symbol_exists(MAP_ANONYMOUS sys/mman.h HAVE_MAP_ANONYMOUS)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(unwind.h HAVE_UNWIND_H)
check_include_file(cpuid.h HAVE_CPUID_H)
check_include_file(sys/prctl.h HAVE_PRCTL_H)

check_symbol_exists(O_DSYNC fcntl.h HAVE_O_DSYNC)
check_function_exists(fdatasync HAVE_FDATASYNC)
check_function_exists(memmem HAVE_MEMMEM)
check_function_exists(memrchr HAVE_MEMRCHR)

#
# Some versions of GNU libc define non-portable __libc_stack_end
# which we use to determine the end (or beginning, actually) of
# stack. Find whether or not it's present.
check_library_exists("" __libc_stack_end "" HAVE_LIBC_STACK_END)

#
# Enable 'make tags' target.
#
add_custom_target(tags COMMAND ctags -R -f tags
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#
# Define PACKAGE_VERSION -- a string constant with tarantool version.
#
set (CPACK_PACKAGE_VERSION_MAJOR "1")
set (CPACK_PACKAGE_VERSION_MINOR "5")
set (CPACK_PACKAGE_VERSION_PATCH "1")

set (PACKAGE_VERSION "")

# Get git version only if source directory has .git repository, this
# avoids git to search .git repository in parent
# directories.
#
if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
	execute_process (COMMAND ${GIT} describe HEAD
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Failed to retrive git version.")
    endif()
endif()

set (VERSION_FILE "${CMAKE_SOURCE_DIR}/VERSION")

# Update version file or use it when there is no git
# repository within sources (source tarballs).
#
if (PACKAGE_VERSION STREQUAL "")
    if (NOT EXISTS "${VERSION_FILE}")
        message (FATAL_ERROR "Version file ${VERSION_FILE} does not exists.")
    endif()
    message (WARNING "Using version from version file ${VERSION_FILE}")
	execute_process (COMMAND ${CAT} ${VERSION_FILE}
		OUTPUT_VARIABLE PACKAGE_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (PACKAGE_VERSION STREQUAL "")
        message (FATAL_ERROR "Unable to retrive version from git or ${VERSION_FILE} file.")
    endif()
else()
	file(WRITE ${VERSION_FILE} "${PACKAGE_VERSION}\n")
endif()

#
# Specify where to look for include files.
#
include_directories("${PROJECT_SOURCE_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/include")
include_directories("${PROJECT_BINARY_DIR}/include")
include_directories("${PROJECT_SOURCE_DIR}/third_party")
#
# Specify prefixes
#
if (NOT DEFINED CMAKE_SYSCONF_DIR)
    set (CMAKE_SYSCONF_DIR "etc")
endif()
if (NOT DEFINED CMAKE_LOCALSTATE_DIR)
    set (CMAKE_LOCALSTATE_DIR "var")
endif()
if (NOT DEFINED CMAKE_MAN_DIR)
    set (CMAKE_MAN_DIR "man")
endif()

#
# Specify system-specific Lua prefixes
#
if (NOT DEFINED LUA_SYSPATH)
    set (LUA_SYSPATH "")
endif()
if (NOT DEFINED LUA_SYSCPATH)
    set (LUA_SYSCPATH "")
endif()

#
# Specify Tarantool modules Lua prefixes
#
if (NOT DEFINED LUA_LIBPATH)
    set (LUA_LIBPATH "")
endif()
if (NOT DEFINED LUA_LIBCPATH)
    set (LUA_LIBCPATH "")
endif()

#
# Now handle all configuration options.
#
option(ENABLE_DOC "Enable building of documentation" OFF)

option(ENABLE_CLIENT "Enable building of console client" OFF)
if (ENABLE_CLIENT)
    set (TARANTOOL_CLIENTS ${TARANTOOL_CLIENTS} "tarantool")
endif()

option(ENABLE_TRACE "Enable debug trace of tarantool_box execution to
a file specified in TARANTOOL_TRACE environment variable" ON)

option(ENABLE_BACKTRACE "Enable output of fiber backtrace information in 'show
fiber' administrative command. Only works on x86 architectures, if compiled
with gcc. If GNU binutils and binutils-dev libraries are installed, backtrace
is output with resolved function (symbol) names. Otherwise only frame
addresses are printed." ${CMAKE_COMPILER_IS_GNUCC})

set (HAVE_BFD False)
if (ENABLE_BACKTRACE)
    if (NOT ${CMAKE_COMPILER_IS_GNUCC} OR
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86|amd64"))
        # We only know this option to work with gcc
        # on x86 architecture.
        message (FATAL_ERROR "ENABLE_BACKTRACE option is set but the system is not x86 based (${CMAKE_SYSTEM_PROCESSOR}) or the compiler is not GNU GCC (${CMAKE_C_COMPILER}).")
    endif()
    # Use GNU bfd if present.
    check_library_exists (bfd bfd_init ""  HAVE_BFD_LIB)
    set(CMAKE_REQUIRED_DEFINITIONS -DPACKAGE=${PACKAGE} -DPACKAGE_VERSION=${PACKAGE_VERSION})
    check_include_file(bfd.h HAVE_BFD_H)
    set(CMAKE_REQUIRED_DEFINITIONS)
    if (HAVE_BFD_LIB AND HAVE_BFD_H)
        set (HAVE_BFD True)
    endif()
endif()

option(ENABLE_STATIC "Perform static linking whenever possible." OFF)
if (ENABLE_STATIC)
    add_compile_flags("C;CXX" "-static")
endif()

##
## Third-Party libraries
##

#
# Since we *optionally* build bundled libs, a direct build
# dependency between tarantool_box and libluajit/libobjc won't
# work: add an empty custom target for this dependency instead.
# If a bundled objc or luajit is built, it is added to the
# dependency list of build_bundled_libs target.
#

add_custom_target(build_bundled_libs)

#
# LibLUAJIT
#
include(luajit)


#
# LibEV
#

#
# Currently our code uses libev with #define EV_MULTIPLICITY 0.
# This option means that libev has a global variable with
# struct ev_loop data.
# Such design is not compatible with the dynamic version of libev
# provided by distros.
set(ENABLE_BUNDLED_LIBEV ON)
include(BuildLibEV)
libev_build()
add_dependencies(build_bundled_libs ev)

#
# LibEIO
#
option(ENABLE_BUNDLED_LIBEIO "Enable building of the bundled libeio" ON)

if (ENABLE_BUNDLED_LIBEIO)
    include(BuildLibEIO)
    libeio_build()
    add_dependencies(build_bundled_libs eio)
else()
    set(LIBEIO_FIND_REQUIRED ON)
    find_package(LibEIO)
endif()


#
# LibCORO
#

#
# Tarantool uses 'coro' (coroutines) library to implement
# cooperative multi-tasking. Since coro.h is included
# universally, define the underlying implementation switch
# in the top level CMakeLists.txt, to ensure a consistent
# header file layout across the entire project.
#
set(ENABLE_BUNDLED_LIBCORO ON)
include(BuildLibCORO)
libcoro_build()
add_dependencies(build_bundled_libs coro)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "86" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "amd64")
    add_definitions("-DCORO_ASM")
else()
    add_definitions("-DCORO_SJLJ")
endif()


#
# LibGOPT
#

include(BuildLibGOPT)
libgopt_build()
add_dependencies(build_bundled_libs gopt)

#
# LibCJSON
#

include(BuildLibCJSON)
libcjson_build()
add_dependencies(build_bundled_libs cjson)

#
# Third-Party misc
#

include(BuildMisc)
libmisc_build()
add_dependencies(build_bundled_libs misc)

option(ENABLE_RPM "Enable install of a RPM specific files" OFF)

# cpack config. called package.cmake to avoid
# conflicts with the global CPack.cmake (On MacOS X
# file names are case-insensitive)
#
include (cmake/package.cmake)
#
# RPM build environment
# CPACK is only used for .tar.gz package generation.
# To build an RPM we need a source package,
# so rpm.cmake depends on package.cmake.
#
include (cmake/rpm.cmake)

add_subdirectory(cfg)
add_subdirectory(connector)
add_subdirectory(src)
add_subdirectory(extra)
add_subdirectory(client)
add_subdirectory(test)
add_subdirectory(doc)

install (FILES README.md LICENSE doc/box-protocol.txt
         DESTINATION share/doc/tarantool)

#
# tarantool info summary (used in server version output)
#
set(TARANTOOL_OPTIONS "-DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_STATIC=${ENABLE_STATIC}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_TRACE=${ENABLE_TRACE} -DENABLE_BACKTRACE=${ENABLE_BACKTRACE}")
set(TARANTOOL_OPTIONS "${TARANTOOL_OPTIONS} -DENABLE_CLIENT=${ENABLE_CLIENT}")
set(TARANTOOL_BUILD "${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_BUILD_TYPE}")
set(TARANTOOL_C_COMPILER ${CMAKE_C_COMPILER})
set(TARANTOOL_CXX_COMPILER ${CMAKE_CXX_COMPILER})

#
# Output compile-time defines into config.h. Do it at the end
# of the script to make sure all variables are set.
#
configure_file(
    "${PROJECT_SOURCE_DIR}/include/tarantool/config.h.cmake"
    "${PROJECT_BINARY_DIR}/include/tarantool/config.h"
    )
configure_file(
    "${PROJECT_SOURCE_DIR}/doc/tnt.ent.cmake"
    "${PROJECT_BINARY_DIR}/doc/tnt.ent"
    )

configure_file(
    "${PROJECT_SOURCE_DIR}/doc/www-data.in/download.cmake"
    "${PROJECT_BINARY_DIR}/doc/www-data.in/download"
    )
message (STATUS "")
message (STATUS "Tarantool configuration is complete:")
message (STATUS "")
message (STATUS "VERSION: ${PACKAGE_VERSION}")
message (STATUS "BUILD: ${TARANTOOL_BUILD}")
message (STATUS "C_COMPILER: ${TARANTOOL_C_COMPILER}")
message (STATUS "CXX_COMPILER: ${TARANTOOL_CXX_COMPILER}")
message (STATUS "C_FLAGS:${TARANTOOL_C_FLAGS}")
message (STATUS "CXX_FLAGS:${TARANTOOL_CXX_FLAGS}")
message (STATUS "PREFIX: ${CMAKE_INSTALL_PREFIX}")
message (STATUS "MODULES: ${TARANTOOL_MODULES}")
message (STATUS "ENABLE_STATIC: ${ENABLE_STATIC}")
message (STATUS "ENABLE_SSE2: ${ENABLE_SSE2}")
message (STATUS "ENABLE_AVX: ${ENABLE_AVX}")
message (STATUS "ENABLE_GCOV: ${ENABLE_GCOV}")
message (STATUS "ENABLE_GPROF: ${ENABLE_GPROF}")
message (STATUS "ENABLE_TRACE: ${ENABLE_TRACE}")
message (STATUS "ENABLE_BACKTRACE: ${ENABLE_BACKTRACE} (symbol resolve: ${HAVE_BFD})")
message (STATUS "ENABLE_CLIENT: ${ENABLE_CLIENT}")
message (STATUS "ENABLE_BUNDLED_LUAJIT: ${ENABLE_BUNDLED_LUAJIT}")
message (STATUS "ENABLE_BUNDLED_LIBEV: ${ENABLE_BUNDLED_LIBEV}")
message (STATUS "ENABLE_BUNDLED_LIBEIO: ${ENABLE_BUNDLED_LIBEIO}")
message (STATUS "ENABLE_BUNDLED_LIBCORO: ${ENABLE_BUNDLED_LIBCORO}")
message (STATUS "ENABLE_DOC: ${ENABLE_DOC}")
list_optional_packages()
message (STATUS "")
message (STATUS "To view or modify configuration results, check out CMakeCache.txt.")
message (STATUS "")

=== src/CMakeLists.txt ===
#
# Set compile flags for entire src/ directory
#
enable_tnt_compile_flags()

if (NOT TARGET_OS_DARWIN)
    add_subdirectory(plugin)
endif()

include_directories(${LIBEV_INCLUDE_DIR})
include_directories(${LIBEIO_INCLUDE_DIR})
include_directories(${LIBCORO_INCLUDE_DIR})
include_directories(${LIBGOPT_INCLUDE_DIR})

# Require pthread globally if compiling with GCC
if (CMAKE_COMPILER_IS_GNUCC)
    add_compile_flags("C;CXX" "-pthread")
endif()

#
# Build admin.cc from admin.rl, but only if admin.rl was changed.
# The same applies to memcached.cc/memcached.rl.
# We track admin.cc and memcached.cc in revision control, and thus do not
# require engineers who do not modify .rl files to have Ragel
# installed.
#
add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/admin.cc
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/admin.rl -o src/admin.cc
    DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.rl)

add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMAND ${RAGEL} -G2 src/memcached-grammar.rl
                     -o src/memcached-grammar.cc
    DEPENDS ${CMAKE_SOURCE_DIR}/src/memcached-grammar.rl)

add_custom_target(generate_admin_cc DEPENDS ${CMAKE_SOURCE_DIR}/src/admin.cc)
add_custom_target(generate_memcached_grammar_cc DEPENDS
    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc)

# do not randomly try to re-generate admin.cc or memcached-grammar.cc
# after a fresh checkout/branch switch.
execute_process(COMMAND ${CMAKE_COMMAND} -E touch_nocreate
    ${CMAKE_SOURCE_DIR}/src/admin.cc
    ${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc)

set_source_files_properties(${CMAKE_SOURCE_DIR}/src/memcached-grammar.cc
    PROPERTIES HEADER_FILE_ONLY true)

set_source_files_properties(memcached.cc
    PROPERTIES COMPILE_FLAGS "-Wno-uninitialized")

#
# # Do not clean admin.cc, memcached.cc or other
# generated files in 'make clean' -- they are under
# revision control.
#
set_property(DIRECTORY PROPERTY CLEAN_NO_CUSTOM true)

# Compile src/lua/*.lua files into src/lua/*.lua.c sources
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/src/lua)
set(lua_sources)
lua_source(lua_sources lua/uuid.lua)

add_custom_target(generate_lua_sources
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/src/box
    DEPENDS ${lua_sources})
set_property(DIRECTORY PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${lua_sources})

#
# Used by modules.
#
set (recompiled_sources
     ${CMAKE_SOURCE_DIR}/src/tarantool.cc
     ${CMAKE_SOURCE_DIR}/src/opts.c
     ${CMAKE_SOURCE_DIR}/src/lua/init.cc
     ${CMAKE_SOURCE_DIR}/src/say.cc
     ${CMAKE_SOURCE_DIR}/src/assoc.cc
     ${CMAKE_SOURCE_DIR}/src/replication.cc
     ${CMAKE_SOURCE_DIR}/src/memcached.cc
     ${CMAKE_SOURCE_DIR}/src/fiber.cc)

set (common_sources
     tbuf.c
     palloc.cc
     util.cc
     sio.cc
     evio.cc
     coio.cc
     coeio.cc
     iobuf.cc
     coio_buf.cc
     salloc.cc
     pickle.cc
     coro.cc
     stat.cc
     log_io.cc
     recovery.cc
     admin.cc
     cpu_feature.c
     replica.cc
     iproto.cc
     iproto_port.cc
     session.cc
     object.cc
     exception.cc
     errcode.c
     errinj.cc
     fio.c
     crc32.c
     rope.c
     ipc.cc
     lua/info.cc
     lua/stat.cc
     lua/slab.cc
     lua/lua_ipc.cc
     lua/lua_socket.cc
     lua/session.cc
     lua/cjson.cc
     ${lua_sources}
)

if (ENABLE_TRACE)
    set (common_sources ${common_sources} trace.c)
endif()

set_source_files_compile_flags(${common_sources})
add_library(core STATIC ${common_sources})
add_dependencies(core generate_headers)

set (common_libraries cfg core)

list(APPEND common_libraries
    ${LIBEV_LIBRARIES}
    ${LIBEIO_LIBRARIES}
    ${LIBCORO_LIBRARIES}
    ${LIBGOPT_LIBRARIES}
    ${LIBCJSON_LIBRARIES}
    ${LUAJIT_LIB}
    misc
)

set (THREAD_LIB pthread)
if (ENABLE_STATIC)
    set (THREAD_LIB -Wl,--whole-archive pthread -Wl,--no-whole-archive)
endif()

set (common_libraries ${common_libraries} ${THREAD_LIB})

if (TARGET_OS_LINUX OR TARGET_OS_DEBIAN_FREEBSD)
    set (common_libraries ${common_libraries} dl)
endif()

if (TARGET_OS_FREEBSD AND NOT TARGET_OS_DEBIAN_FREEBSD)
    set (common_libraries ${common_libraries} intl)
endif()

if (ENABLE_BACKTRACE AND HAVE_BFD)
    set (common_libraries ${common_libraries} bfd)
    if (NOT TARGET_OS_DARWIN)
        set (common_libraries ${common_libraries} iberty)
    endif()
    if (ENABLE_STATIC OR TARGET_OS_FREEBSD)
        include (FindZLIB)
        set (common_libraries ${common_libraries} ${ZLIB_LIBRARIES})
    endif()
    if (TARGET_OS_FREEBSD)
    	if (NOT TARGET_OS_DEBIAN_FREEBSD)
	        set (common_libraries ${common_libraries} iconv)
        endif()
    endif()
endif()

set (common_libraries ${common_libraries} PARENT_SCOPE)

add_subdirectory(lib)
# Save CMAKE_XXX_FLAGS from this directory for config.h (used in --version)
set(TARANTOOL_C_FLAGS ${CMAKE_C_FLAGS} PARENT_SCOPE)
set(TARANTOOL_CXX_FLAGS ${CMAKE_CXX_FLAGS} PARENT_SCOPE)

function(tarantool_module mod)
    set (module_sources ${ARGN})
    set(cfg_c_flags "-Wno-unused -Wno-unused-parameter")
    if (CMAKE_COMPILER_IS_CLANG)
        set(cfg_c_flags "${cfg_c_flags} -Wno-semicolon-before-method-body")
    endif()
    set_source_files_properties(
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c
        PROPERTIES COMPILE_FLAGS ${cfg_c_flags}
        GENERATED True)
    unset(cfg_c_flags)
    add_executable(tarantool_${mod}
        ${module_sources}
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.c)

    set_source_files_properties(${recompiled_sources}
        PROPERTIES OBJECT_DEPENDS
        ${CMAKE_SOURCE_DIR}/cfg/tarantool_${mod}_cfg.h)

    set_source_files_compile_flags(
        ${recompiled_sources} ${module_sources})

    add_library(lt${mod} STATIC ${recompiled_sources})
    set_target_properties(lt${mod} PROPERTIES COMPILE_FLAGS
        "-DTARANTOOL_CONFIG='<cfg/tarantool_${mod}_cfg.h>'")
    add_dependencies(lt${mod} generate_headers generate_admin_cc generate_memcached_grammar_cc build_bundled_libs)

    target_link_libraries(tarantool_${mod} lt${mod} ${common_libraries})

    if (ENABLE_STATIC)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_SEARCH_END_STATIC ON)
        set (module_link_flags "${module_link_flags} -static")
    endif()

    if (module_link_flags)
        set_target_properties(tarantool_${mod} PROPERTIES
            LINK_FLAGS ${module_link_flags})
    endif()
    install (TARGETS tarantool_${mod} DESTINATION bin)
endfunction()

foreach (module ${TARANTOOL_MODULES})
add_subdirectory(${module})
endforeach()

=== src/plugin/mysql/CMakeLists.txt ===
find_optional_package(MySQL)

if (MYSQL_FOUND)
	message(STATUS "box.net.sql(mysql) INC=${MYSQL_INCLUDE_DIRS}")
	message(STATUS "box.net.sql(mysql) LIBS=${MYSQL_LIBRARIES}")
	
	include_directories(${MYSQL_INCLUDE_DIRS})
	add_library(mysql SHARED mysql.cc)
	target_link_libraries(mysql ${MYSQL_LIBRARIES})
	install(TARGETS mysql LIBRARY DESTINATION ${PLUGIN_DIR})
else()
	message(STATUS "MySQL client not found, box.net.sql(mysql) disabled")
endif()

=== src/plugin/pg/CMakeLists.txt ===
# A special hack for buggy FindPostgreSQL.cmake in Debian/Ubuntu
set(PostgreSQL_ROOT /usr/include/postgresql;/usr/include/postgres)
find_optional_package(PostgreSQL)
if (PostgreSQL_FOUND)
	message(STATUS "box.net.sql(pg): INC=${PostgreSQL_INCLUDE_DIRS}")
	message(STATUS "box.net.sql(pg): LIBS=${PostgreSQL_LIBRARIES}")

	include_directories(${PostgreSQL_INCLUDE_DIRS})
	add_library(pg SHARED pg.cc)
	target_link_libraries(pg ${PostgreSQL_LIBRARIES})
	install(TARGETS pg LIBRARY DESTINATION ${PLUGIN_DIR})

else()
	message(STATUS "PostgreSQL client not found, box.net.sql(pg) disabled")
endif()

=== debian/changelog ===
tarantool (1.5.1.84.g9f2e646-1) unstable; urgency=low

  * Drop BSD dependencies in Debian/kFreeBSD (try to fix FTBFS with Debian/BSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 09 Sep 2013 15:52:39 +0400

tarantool (1.5.1.82.ga064ebe-1) unstable; urgency=low

  * Remove tarantool/config.h pointedly (try to fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Mon, 09 Sep 2013 13:35:06 +0400

tarantool (1.5.1.81.g4382f16-1) unstable; urgency=low

  * Fix debian/rules clean section (cleanup CMake files).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 23:05:29 +0400

tarantool (1.5.1.80.gc84e35c-1) unstable; urgency=low

  * New snapshot (try to fix FTBFS with Debian/kFreeBSD).

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 22:14:09 +0400

tarantool (1.5.1.78.g2e82d26-1) unstable; urgency=low

  * New snapshot. Integration upload.
   - Add missing copyright holders, closes: #722059
   - Drop non-free materials from tarbal, closes: #722060
   - Fix memory leak in box.ipc.channel:put.

 -- Dmitry E. Oboukhov <unera@debian.org>  Sun, 08 Sep 2013 02:00:51 +0400

tarantool (1.5.1.76.g5ed3fbe-1) unstable; urgency=low

  * New snapshot.
   - Fix memory leak in box.ipc.channel:put(v, 0)

 -- Dmitry E. Oboukhov <unera@debian.org>  Thu, 05 Sep 2013 14:36:52 +0400

tarantool (1.5.1.73.gd1b3db6-1) unstable; urgency=low

  * New snapshot
   - Fix crashes with broken snapshot.
   - Cleanup debian/copyright (drop php-connector section).
   - Drop empty TODO files from binary packages.
   - debian/* relicensed as tarantool.
   - tarantool-plugins has 'any' architecture: it depends on plugins
     that contain ELF-files.
   - Fix FTBFS with Debian/kFreeBSD, closes: #715358.
   - Drop irrelevant debian/README.source.
   - Add postgresql-plugin package.
   - Add mysql-plugin package.
   - Add -plugins package (Now it depends on other plugin. Then it will
     contain some internal tarantool plugins).
   - Remove non-free rfc4627.txt.
   - Update debian/copyright.

 -- Dmitry E. Oboukhov <unera@debian.org>  Wed, 04 Sep 2013 12:45:34 +0400

=== debian/control ===
Source: tarantool
Priority: optional
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper (>= 8),
 cmake,
 libreadline-dev,
 python-yaml,
 python-daemon,
 python-pexpect,
 libncurses5-dev,
 binutils-dev,
 libmysqlclient-dev,
 libpq-dev
Section: database
Standards-Version: 3.9.3
Homepage: http://tarantool.org/
VCS-Browser: https://github.com/tarantool/tarantool
VCS-Git: git://github.com/tarantool/tarantool.git

Package: tarantool-common
Architecture: all
Priority: optional
Depends: ${misc:Depends}, adduser
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides configs and logs infrastructure for tarantool.

Package: tarantool
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, tarantool-common
Suggests: libmr-tarantool-perl, libdr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides tarantool server.

Package: tarantool-plugins
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool (= ${binary:Version}),
 tarantool-postgresql-plugin,
 tarantool-mysql-plugin
Suggests: libmr-tarantool-perl, libdr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides (or depends on) all tarantool plugins.

Package: tarantool-postgresql-plugin
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool (= ${binary:Version})
Suggests: libmr-tarantool-perl, libdr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package contains connector for PostgreSQL database for tarantool
 lua stored procedures.

Package: tarantool-mysql-plugin
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends},
 tarantool (= ${binary:Version})
Suggests: libmr-tarantool-perl, libdr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package contains connector for MySQL database for tarantool
 lua stored procedures.

Package: tarantool-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for tarantool.

Package: tarantool-client
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libmr-tarantool-perl
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool.

Package: tarantool-client-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     tarantool-client (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides readline client for tarantool (debug symbols).

Package: libtarantool1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool.

Package: libtarantool1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantool1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantool1.

Package: libtarantool-dev
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
 libtarantool1 (= ${binary:Version}),
 libtarantoolnet1 (= ${binary:Version}),
 libtarantoolsql1 (= ${binary:Version}),
 libtarantoolrpl1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides headers for libtarantool* libraries.

Package: libtarantoolnet1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides c-connector library for tarantool (network).

Package: libtarantoolnet1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolnet1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolnet1.

Package: libtarantoolsql1
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides SQL-parser for tarantool.

Package: libtarantoolsql1-dbg
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386
Priority: extra
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends},
     libtarantoolsql1 (= ${binary:Version})
Description: high performance key/value storage server
 Tarantool is an open-source NoSQL database, developed by Mail.ru.
 Its key properties include:
 .
  * all data is maintained in RAM
  * data persistence is implemented using Write Ahead Log and snapshotting
  * supports asynchronous replication and hot standby
  * uses coroutines and asynchronous I/O to implement high-performance
    lock-free access to data
  * available on Linux and FreeBSD
  * stored procedures in Lua are supported
 .
 This package provides debug symbols for libtarantoolsql1.
